#include <config.h>

#define DISABLE_DEPRECATED_METHOD_CHECK 1

#include <dune/grid/sgrid.hh>
#include <dune/grid/test/gridcheck.cc>
#include <dune/grid/test/checkintersectionit.cc>


#include <dune/grid/identitygrid.hh>



using namespace Dune;


// test IdentityGrid for given dimension
template <int dim>
void testDim()
{
    typedef SGrid<dim,dim> GridType;
    int n[dim];
    double h[dim];
    
    for (int i=0; i<dim; ++i)
        {
            n[i] = 1;
            h[i] = 1.0;
        }

    GridType grid(n,h);

    grid.globalRefine(1);

    typedef typename GridType::template Codim<0>::LevelIterator HostElementIterator;
    typedef typename IdentityGrid<GridType>::template Codim<0>::LevelIterator ElementIterator;

    IdentityGrid<GridType> identityGrid(grid);

    gridcheck(identityGrid);
    checkIntersectionIterator(identityGrid);

}


int main (int argc, char *argv[]) try
{
    testDim<1>();
    testDim<2>();
    testDim<3>();
} 
// //////////////////////////////////
//   Error handler
// /////////////////////////////////
 catch (Exception e) {

    std::cout << e << std::endl;
    return 1;
 }
